Index: trunk/BNC/bnchelp.html
===================================================================
--- trunk/BNC/bnchelp.html	(revision 1049)
+++ trunk/BNC/bnchelp.html	(revision 1051)
@@ -47,5 +47,5 @@
 <p>
 <ul>
-<li>RTCM Version 2.x containing message types 18 and 19 or 20 and 21 (GPS and GLONASS), </li> 
+<li>RTCM Version 2.x containing message types 18 and 19 or 20 and 21 together with 3 and 22 (GPS and GLONASS), </li> 
 <li>RTCM Version 3.x containing message types 1002 (GPS, SBAS) or 1004 (GPS), 1010 or 1012 (GLONASS), 1019 or 1020 (broadcast ephemeris), 4056 and 4057 (tentative messages for orbit and clock corrections to broadcast ephemeris)</li>
 <li>RTIGS containing GPS record types 200 (observations) and 300 (ephemeris).</li>
@@ -687,8 +687,8 @@
 </li>
 <li>
-Using RTCM Version 2.x, BNC will only handle message types 18 and 19 or 20 and 21. Using RTCM Version 3.x, BNC will properly handle message types 1002, 1004, 1010, and 1012. Note that when handling message types 1001, 1003, 1009 and 1011 where the ambiguity field is not set, the output will be no valid RINEX. All values will be stored modulo 299792.458 (speed of light).
-</li>
-<li>
-For using RTCM Version 2.x streams carrying message types 20 and 21 (carrier phase and pseudo-range corrections), broadcast ephemeris are needed. Hence, whenever dealing with message types 20 and 21, make sure that broadcast ephemeris become available for BNC through also retrieving at least one RTCM Version 3.x stream carrying message types 1019 (GPS ephemeris) and 1020 (GLONASS ephemeris).
+Using RTCM Version 3.x, BNC will properly handle message types 1002, 1004, 1010, and 1012. Note that when handling message types 1001, 1003, 1009 and 1011 where the ambiguity field is not set, the output will be no valid RINEX. All values will be stored modulo 299792.458 (speed of light).
+</li>
+<li>
+Using RTCM Version 2.x, BNC will only handle message types 18 and 19 or 20 and 21 together with position and the antenna offset information carried in types 3 and 22. Note that processing carrier phase corrections and pseudo-range corrections contained in message types 20 and 21 needs access to broadcast ephemeris. Hence, whenever dealing with message types 20 and 21, make sure that broadcast ephemeris become available for BNC through also retrieving at least one RTCM Version 3.x stream carrying message types 1019 (GPS ephemeris) and 1020 (GLONASS ephemeris).
 </li>
 <li>
@@ -733,5 +733,5 @@
 James Perlt, BKG, helped fixing bugs and redesigned BNC's main window.<br>
 Andre Hauschild, German Space Operations Center, DLR, revised the RTCMv2 decoder.<br>
-Zdenek Lukes, Czech Technical University Prague, Department of Geodesy, extended the RTCMv2 decoder to handle message types 20 and 21 and added output of loss of lock indicator.<br>
+Zdenek Lukes, Czech Technical University Prague, Department of Geodesy, extended the RTCMv2 decoder to handle message types 3, 20, 21, and 22 and added output of loss of lock indicator.<br>
 </p>
 
@@ -758,5 +758,5 @@
 <tr><td>Jul 2007 &nbsp;</td><td>Version 1.4 &nbsp;</td><td>[Bug] Skip messages from proxy server<br> [Bug] Call RINEX script through 'nohup'</td></tr>
 <tr><td>Apr 2008 &nbsp;</td><td>Version 1.5 &nbsp;</td><td>[Add] Handle ephemeris from RTCM Version 3.x streams<br> [Add] Upgrade to Qt Version 4.3.2<br> [Add] Optional RINEX v3 output<br> [Add] SBAS support<br> [Bug] RINEX skeleton download following stream outage<br> [Add] Handle ephemeris from RTIGS streams<br> [Add] Monitor stream failure/recovery and latency<br> [Mod] Redesign of main window<br> [Bug] Freezing of About window on Mac systems<br> [Bug] Fixed problem with PRN 32 in RTCMv2 decoder<br> [Bug] Fix for Trimble 4000SSI receivers in RTCMv2 decoder<br> [Mod] Major revision of input buffer in RTCMv2 decoder</td></tr>
-<tr><td>September 2008 &nbsp;</td><td>Version 1.6 &nbsp;</td><td>[Mod] Fill blanc columns in RINEXv3 with 0.000<br> [Add] RTCM v3 decoder for clock and orbit corrections<br>[Add] Check RTCM v3 streams for incoming message types<br> [Add] Decode RTCMv2 message types 20 and 21<br>[Add] Loss of lock indicator</td></tr>
+<tr><td>September 2008 &nbsp;</td><td>Version 1.6 &nbsp;</td><td>[Mod] Fill blanc columns in RINEXv3 with 0.000<br> [Add] RTCM v3 decoder for clock and orbit corrections<br>[Add] Check RTCM v3 streams for incoming message types<br> [Add] Decode RTCMv2 message types 3, 20, 21, and 22<br>[Add] Loss of lock indicator</td></tr>
 </table>
 </p>