Index: trunk/BNC/bnchelp.html
===================================================================
--- trunk/BNC/bnchelp.html	(revision 1119)
+++ trunk/BNC/bnchelp.html	(revision 1120)
@@ -48,5 +48,5 @@
 <ul>
 <li>RTCM Version 2.x containing message types 18 and 19 or 20 and 21 together with 3 and 22 (GPS and GLONASS), </li> 
-<li>RTCM Version 3.x containing message types 1002 (GPS, SBAS) or 1004 (GPS), 1010 or 1012 (GLONASS), 1019 or 1020 (broadcast ephemeris), 4056 and 4057 (tentative messages for orbit and clock corrections to broadcast ephemeris)</li>
+<li>RTCM Version 3.x containing message types 1002 (GPS, SBAS) or 1004 (GPS), 1010 or 1012 (GLONASS), 1019 or 1020 (broadcast ephemeris), 4056 and 4057 (premature messages for orbit and clock corrections to broadcast ephemeris)</li>
 <li>RTIGS containing GPS record types 200 (observations) and 300 (ephemeris).</li>
 </ul>
@@ -102,5 +102,5 @@
 &nbsp; &nbsp; &nbsp; 3.9.5. <a href=#advscript>Advisory Script</a><br>
 &nbsp; &nbsp; &nbsp; 3.9.6. <a href=#perflog>Performance Log</a><br>
-3.10. <a href=#messtypes>RTCM Message Types</a><br>
+3.10. <a href=#messtypes>RTCM Scan</a><br>
 &nbsp; &nbsp; &nbsp; 3.10.1. <a href=#messmount>Mountpoint</a><br>
 3.11. <a href=#mountpoints>Mountpoints</a><br>
@@ -409,5 +409,5 @@
 <p>
 </p>
-RTCM is in the process of developing new Version 3 messages to transport satellite clock and orbit corrections in real-time. Based on the latest available proposal, the following tentative messages currently under discussion have been implemented in BNC:
+RTCM is in the process of developing new Version 3 messages to transport satellite clock and orbit corrections in real-time. Based on the latest available proposal, the following premature messages currently under discussion have been implemented in BNC:
 <ul>
 <li>Message type 4050: GPS orbit corrections to Broadcast Ephemeris</li>
@@ -579,12 +579,19 @@
 </p>
 
-<p><a name="messtypes"><h4>3.10. RTCM Message Types</h4></p>
-<p>
-When configuring a GNSS receiver for RTCM stream generation, the setup interface may not provide details about RTCM message types. As reliable information concerning stream contents should be available i.e. for NTRIP broadcaster operators to maintain the broadcaster's sourcetable, BNC allows to check RTCM Version 3.x streams for incoming message types and their repetition rates. The idea for this option arose from 'InspectRTCM', a comprehensive stream analyzing tool written by D. Stoecker.
+<p><a name="messtypes"><h4>3.10. RTCM Scan</h4></p>
+<p>
+When configuring a GNSS receiver for RTCM stream generation, the setup interface may not provide details about RTCM message types. As reliable information concerning stream contents should be available i.e. for NTRIP broadcaster operators to maintain the broadcaster's sourcetable, BNC allows to scan RTCM Version 3.x streams for incoming message types and their repetition rates. The idea for this option arose from 'InspectRTCM', a comprehensive stream analyzing tool written by D. Stoecker.
 </p>
 
 <p><a name="messmount"><h4>3.10.1 Mountpoint - optional</h4></p>
 <p>
-Specify the mountpoint of an RTCM Version 3.x stream to log the numbers of incoming message types. Logged time stamps refer to message reception time and allow to understand repetition rates. Enter 'ALL' if you want to log message type numbers of all configured streams. Beware that the size of the logfile can rapidly increase depending on the number of incoming RTCM Version 3.x streams. 
+Specify the mountpoint of an RTCM Version 3.x stream to scan it and log
+</p>
+<ul>
+<li>numbers of incoming message types</li>
+<li>Antenna Reference Point (ARP) coordinates in ITRF reference system</li>
+<li>antenna height.</li>
+</ul>
+<p>Logged time stamps refer to message reception time and allow to understand repetition rates. Enter 'ALL' if you want to log this information from all configured streams. Beware that the size of the logfile can rapidly increase depending on the number of incoming RTCM Version 3.x streams. 
 </p>
 <p>This option is primarily meant for testing and evaluation. Use it to figure out what exactly is produced by a specific GNSS receiver's configuration. An empty option field (default) means that you don't want BNC to print the message type numbers carried in RTCM Version 3.x streams.
@@ -684,5 +691,5 @@
 Using RTCM Version 3.x, BNC will properly handle message types 1002, 1004, 1010, and 1012. Note that when handling message types 1001, 1003, 1009 and 1011 where the ambiguity field is not set, the output will be no valid RINEX. All values will be stored modulo 299792.458 (speed of light).
 </li>
-Concerning the length of data fields in RTCM Version 3.x tentative message types 4056 and 4057 (corrections to Broadcast Ephemeris), a decision is not yet available. Note the what's implemented in BNC is just a temporary solutions.
+Concerning the length of data fields in RTCM Version 3.x premature message types 4056 and 4057 (corrections to Broadcast Ephemeris), a decision is not yet available. Note the what's implemented in BNC is just a temporary solutions.
 <li>
 Using RTCM Version 2.x, BNC will only handle message types 18 and 19 or 20 and 21 together with position and the antenna offset information carried in types 3 and 22. Note that processing carrier phase corrections and pseudo-range corrections contained in message types 20 and 21 needs access to broadcast ephemeris. Hence, whenever dealing with message types 20 and 21, make sure that broadcast ephemeris become available for BNC through also retrieving at least one RTCM Version 3.x stream carrying message types 1019 (GPS ephemeris) and 1020 (GLONASS ephemeris).