Index: trunk/BNC/bncgetthread.cpp
===================================================================
--- trunk/BNC/bncgetthread.cpp	(revision 1234)
+++ trunk/BNC/bncgetthread.cpp	(revision 1235)
@@ -765,20 +765,26 @@
                                        dL2[0], dL2[1], dL2[2]) == success ) {
 
-                ostringstream msg2; msg2.setf(ios::fixed);
-                msg2 << "station coordinates " << staID().data()
-                     << ' ' << setw(14) << setprecision(5) << stax
-                     << ' ' << setw(14) << setprecision(5) << stay
-                     << ' ' << setw(14) << setprecision(5) << staz
-                     << " L1 "
-                     << ' ' << setw(8)  << setprecision(5) << dL1[0]
-                     << ' ' << setw(8)  << setprecision(5) << dL1[1]
-                     << ' ' << setw(8)  << setprecision(5) << dL1[2]
-                     << " L2 "
-                     << ' ' << setw(8)  << setprecision(5) << dL2[0]
-                     << ' ' << setw(8)  << setprecision(5) << dL2[1]
-                     << ' ' << setw(8)  << setprecision(5) << dL2[2] 
-                     << ends;
+                if ( _checkMountPoint == _staID || _checkMountPoint == "ALL" ) {
+                  QString ant1;
+                  ant1 =  QString("%1 ").arg(stax,0,'f',4);
+                  emit(newMessage(_staID + ": ARP X " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(stay,0,'f',4);
+                  emit(newMessage(_staID + ": ARP Y " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(staz,0,'f',4);
+                  emit(newMessage(_staID + ": ARP Z " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(dL1[0],0,'f',4);
+                  emit(newMessage(_staID + ": L1 APC DX " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(dL1[1],0,'f',4);
+                  emit(newMessage(_staID + ": L1 APC DY " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(dL1[2],0,'f',4);
+                  emit(newMessage(_staID + ": L1 APC DZ " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(dL2[0],0,'f',4);
+                  emit(newMessage(_staID + ": L2 APC DX " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(dL2[1],0,'f',4);
+                  emit(newMessage(_staID + ": L2 APC DY " + ant1.toAscii() + "m" ));
+                  ant1 =  QString("%1 ").arg(dL2[2],0,'f',4);
+                  emit(newMessage(_staID + ": L2 APC DZ " + ant1.toAscii() + "m" ));
+                }
 	    	_rnx_set_position = true;
-                emit newMessage(QByteArray(msg2.str().c_str()));
               }
             }  
Index: trunk/BNC/bnchelp.html
===================================================================
--- trunk/BNC/bnchelp.html	(revision 1234)
+++ trunk/BNC/bnchelp.html	(revision 1235)
@@ -618,20 +618,31 @@
 <p><a name="messtypes"><h4>3.10. RTCM Scan</h4></p>
 <p>
-When configuring a GNSS receiver for RTCM stream generation, the setup interface may not provide details about RTCM message types. As reliable information concerning stream contents should be available i.e. for NTRIP broadcaster operators to maintain the broadcaster's sourcetable, BNC allows to scan RTCM Version 3.x streams for incoming message types and printout some of the contained meta-data. The idea for this option arose from 'InspectRTCM', a comprehensive stream analyzing tool written by D. Stoecker.
+When configuring a GNSS receiver for RTCM stream generation, the setup interface may not provide details about RTCM message types. As reliable information concerning stream contents should be available i.e. for NTRIP broadcaster operators to maintain the broadcaster's sourcetable, BNC allows to scan RTCM streams for incoming message types and printout some of the contained meta-data. The idea for this option arose from 'InspectRTCM', a comprehensive stream analyzing tool written by D. Stoecker.
 </p>
 
 <p><a name="messmount"><h4>3.10.1 Mountpoint - optional</h4></p>
 <p>
-Specify the mountpoint of an RTCM Version 3.x stream to scan it and log
+Specify the mountpoint of an RTCM Version 3.x stream to scan it and log all contained
 </p>
 <ul>
 <li>numbers of incoming message types</li>
 <li>Antenna Reference Point (ARP) coordinates in ITRF reference system</li>
-<li>antenna height</li>
+<li>antenna height above ARP</li>
 <li>antenna descriptor.</li>
 </ul>
-<p>Logged time stamps refer to message reception time and allow to understand repetition rates. Enter 'ALL' if you want to log this information from all configured streams. Beware that the size of the logfile can rapidly increase depending on the number of incoming RTCM Version 3.x streams. 
-</p>
-<p>This option is primarily meant for testing and evaluation. Use it to figure out what exactly is produced by a specific GNSS receiver's configuration. An empty option field (default) means that you don't want BNC to print the message type numbers carried in RTCM Version 3.x streams.
+</p>
+<p>
+Specify the mountpoint of an RTCM Version 2.x stream and the 'RINEX Observations' directory to scan the stream and log the very first incoming
+</p>
+<ul>
+<li>Antenna Reference Point (ARP) coordinates</li>
+<li>ECEF corrections to ARP for the L1 Antenna Phase Center (APC)</li>
+<li>ECEF corrections to ARP for the L2 Antenna Phase Center (APC).</li>
+</ul>
+<p>
+
+<p>Logged time stamps refer to message reception time and - in case of an RTCM Version 3.x stream - allow to understand repetition rates. Enter 'ALL' if you want to log this information from all configured streams. Beware that the size of the logfile can rapidly increase depending on the number of incoming RTCM streams. 
+</p>
+<p>This option is primarily meant for testing and evaluation. Use it to figure out what exactly is produced by a specific GNSS receiver's configuration. An empty option field (default) means that you don't want BNC to print the message type numbers and antenna information carried in RTCM streams.
 </p>
 
Index: trunk/BNC/bncwindow.cpp
===================================================================
--- trunk/BNC/bncwindow.cpp	(revision 1234)
+++ trunk/BNC/bncwindow.cpp	(revision 1235)
@@ -293,5 +293,5 @@
   _ephV3CheckBox->setWhatsThis(tr("The default format for RINEX Navigation files containing Broadcast Ephemeris is RINEX Version 2.11. Select 'Version 3' if you want to save the ephemeris in RINEX Version 3 format."));
   _rnxV3CheckBox->setWhatsThis(tr("The default format for RINEX Observation files is RINEX Version 2.11. Select 'Version 3' if you want to save the observations in RINEX Version 3 format."));
-  _messTypesLineEdit->setWhatsThis(tr("<p>Specify the mountpoint of an RTCM Version 3.x stream to log the numbers of incoming message types as well as contained antenna coordinates and antenna hight.</p><p>An empty option field (default) means that you don't want BNC to log such information.</p>"));
+  _messTypesLineEdit->setWhatsThis(tr("<p>Specify the mountpoint of an RTCM Version 3.x stream to log the numbers of incoming message types as well as contained antenna coordinates and antenna height.</p><p>Specify the mountpoint of an RTCM Version 2.x stream to log the antenna coordinates and the corrections to L1 and L2 antenna phase centers. Setting the 'RINEX Observations' directory is a precondition.</p><p>An empty option field (default) means that you don't want BNC to log such information.</p>"));
 
   // Canvas with Editable Fields
@@ -355,5 +355,5 @@
   sLayout->addWidget(new QLabel("Sampling"),                      3, 0);
   sLayout->addWidget(_binSamplSpinBox,                            3, 1, Qt::AlignLeft);
-  sLayout->addWidget(new QLabel("Output decoded observations in binary format to feed a real-time GNSS engine."),4,0,1,30);
+  sLayout->addWidget(new QLabel("Output decoded observations in a binary format to feed a real-time GNSS engine."),4,0,1,30);
   sLayout->addWidget(new QLabel("    "),5,0);
   sgroup->setLayout(sLayout);
@@ -394,5 +394,5 @@
   rLayout->addWidget(new QLabel("Mountpoint"),                    0, 0, Qt::AlignLeft);
   rLayout->addWidget(_messTypesLineEdit,                          0, 1,1,15,Qt::AlignLeft);
-  rLayout->addWidget(new QLabel("Scan RTCM Version 3.x stream to log numbers of message types and antenna information."),1, 0, 1, 4, Qt::AlignLeft);
+  rLayout->addWidget(new QLabel("Scan RTCM stream to log numbers of message types and antenna information."),1, 0, 1, 4, Qt::AlignLeft);
   rLayout->addWidget(new QLabel("    "),                          2, 0);
   rLayout->addWidget(new QLabel("    "),                          3, 0);